﻿package 
{
	import flash.display.Sprite;
	import flash.media.Microphone;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;
	import fl.transitions.TweenEvent;
	import flash.events.Event;
	import flash.events.ActivityEvent;
	import flash.system.Security;

	public class WindFarm extends Sprite
	{
		private var started:Boolean;
		private var mic:Microphone = Microphone.getMicrophone();

		public function WindFarm():void
		{
			Security.showSettings("2");
			mic.setLoopBack(true);

			if (mic != null)
			{
				mic.setUseEchoSuppression(true);
				mic.addEventListener(ActivityEvent.ACTIVITY, activityHandler);
			}
		}

		private function activityHandler(event:ActivityEvent):void
		{
			stage.addEventListener(Event.ENTER_FRAME, rotateTurbines);
		}

		private function rotateTurbines(e:Event):void
		{
			if (mic.activityLevel < 20 && mic.activityLevel > 10 && started)
			{
				var tween;
				
				tween = new Tween(turbine,"rotation",Strong.easeOut,turbine.rotation,turbine.rotation + 720,3,true);
				tween = new Tween(turbine2,"rotation",Strong.easeOut,turbine.rotation,turbine.rotation + 720,3,true);
				tween = new Tween(turbine3,"rotation",Strong.easeOut,turbine.rotation,turbine.rotation + 720,3,true);
				tween = new Tween(turbine4,"rotation",Strong.easeOut,turbine.rotation,turbine.rotation + 720,3,true);
				
				tween.addEventListener(TweenEvent.MOTION_FINISH, onMotionFinish);
			}
			else if (mic.activityLevel > 20)
			{
				started = true;

				turbine.rotation += mic.activityLevel;
				turbine2.rotation += mic.activityLevel;
				turbine3.rotation += mic.activityLevel;
				turbine4.rotation += mic.activityLevel;
			}
		}

		private function onMotionFinish(e:TweenEvent):void
		{
			started = false;
		}
	}
}